Subject: H.248 SDP Version Determination Package; Re: Replacement of obsoleted RFC 2327 by RFC 4566; RE: [Megaco] ETSI H.248 Ia Profile: issue with media value '-'in SDP"m=" line

From: [email-masked]
Date: Tue, 10 Oct 2006 08:44:24 +0200

fyi, due to the results of the Ottawa meeting

   http://ftp3.itu.int/av-arch/avc-site/2005-2008/0608_Ott/TD-13a.zip,

we did work on an initial design for a H.248.SDPVER package.

We'll present next week our first draft at ETSI TISPAN#11-Ter meeting:
   11tTD109 SDP Version Determination at H.248 Interfaces - Discussion of a
   correspondent H.248.SDPVER Package Design

Concerning the field value "-" in "m=" line fields in ES 283 018 v1.1.1,
we've prepared following CR:

   11tTD107 WI-03089 H.248 Ia Profile V1 CR Note to SDP syntax
   specification for m= line in § 5.15

- Albrecht

                      Albrecht                                                                                                        
                      SCHWARZ/DE/ALCAT         To:      "Kevin Boyle" <[email-masked]>                                             
                      EL@ALCATEL               cc:      [email-masked]                                                               
                                               Subject: Replacement of obsoleted RFC 2327 by RFC 4566;  RE: [Megaco] ETSI H.248 Ia    
                      16.08.2006 09:58         Profile: issue with media value '-'in SDP"m=" line                                     

fyi,
we've prepared a contribution for the Ottawa meeting, providing an initial
cross-check and correspondent change proposals for H.248.1.

One worthwhile conclusion could be, to allow syntactical/sematical SDP
extensions if required by H.248 packages/profiles, under the condition,
that such extensions will not require changes of the "formal specification
rules" of the underlying SDP grammar. That means, the basic ABNF grammar
behind SDP (RFC 2327 or RFC 4566; complemented by § 7.1.8/H.248.1 SDP
rules) will not be changed in such situations.

Such a proceeding would allow to keep at least the SDP encoder/decoder
(parser) unchanged in the H.248 "core protocol stack". (Note: I know that
this is an implementation specific item, but I'm sure, the experts familiar
with protocol stack implementations know what I mean.)

- Albrecht

                      "Kevin Boyle"

                      <[email-masked]         To:      "Christian Groves"
<[email-masked]>, "Christer Holmberg
                      om>                      \(JO/LMF\)"
<[email-masked]>
                                               cc:      [email-masked]

                      15.08.2006 19:14         Subject: RE: [Megaco] ETSI
H.248 Ia Profile: issue with media value  '-'in SDP"m="
                                               line

It appears to me that we have another item for the "v4" list.  The
updating of the reference from 2327 to 4566 is going to require a number
of changes throughout H.248.1.  Now, we might be able to start work on
just that so that the pain is lessened later on, and if we find that the
changes turn out to be relatively small, then maybe we can issue an
amendment to the v3 spec... or maybe not -- it all depends on what will
have to change.

We were smart enough (well, not me, but the original folks drafting the
text lo these many years ago) to keep the encoding from becoming a
fully-incorporated portion of the ABNF, so updates to the SDP syntax do
NOT affect text encoding.  Binary is a little different story, since the
SDP is not carried through as binary-encoded text.  This is where I
foresee the syntax issues to appear.

Kevin

-----Original Message-----
From: Christian Groves [mailto:[email-masked]]
Sent: Monday, August 07, 2006 3:45 AM
To: Christer Holmberg (JO/LMF)
Cc: [email-masked]
Subject: Re: [Megaco] ETSI H.248 Ia Profile: issue with media value
'-'in SDP"m=" line

Hello Christer,

Please see my response below [CNG].

Cheers, Christian

Christer Holmberg (JO/LMF) wrote:

>Hi Christian,
>
>
>
>>You could use:
>>
>>m = application 1233456 udp application/octet-stream
>>
>>
>
>I guess you should change order of "udp" and "application/octet-stream"
(assuming "udp" is the fmt value)?
>
>Anyway, I think "data" would fit better than "application".
>
>
[CNG] Isn't the format of m=?:    m=<media> <port> <transport> <fmt
list>
and for <fmt list> "From RFC2327: Formats for non-RTP media should be
registered as MIME content types as described in Appendix B."
If "data" isn't supported then an "application" of  "octet stream"
sounds to me a good fit what an media unaware MG is handling.

>
>
>>Yes H.248.20 does use "-" in the  c = however it is allowed to do this
by RFC2327.
>>
>>
>
>Yes, but H.248.1, nor RFC2327, defines the USAGE of "-". It is done in
H.248.20.
[CNG] At least we agree that H.248.1 isn't the place to do it. The key
is the syntax allows it.

>
>
>>So there seems to be some disagreement between the proponents of "-"
>>of whether this is a general mechanism or for specific parameters. I
>>would have thought both media aware and media unaware gateways would
be interested in receiving valid SDP.
>>
>>For H.248.1 v1, v2, v3 implementations which are based on RFC2327 the
>>use of "-" is not supported for the m= line. A subsequent version of
>>H.248.1 could be based on RFC4566 and would then allow the use of "-"
in m=. I'm little hesitant in saying "-" can be used in ANY SDP field if
it has not been allowed even in RFC4566.
>>
>>
>
>As I said before, H.248.1 already uses values (CHOOSE and ALL) in
places NOT supported by RFC2327, so from that perspective I don't see
any syntax problem by also allowing "-". I don't even think updating the
reference to RFC4566 is going to change that fact. I do, however, agree
that adding text about "-" to H.248.1 is considered new functionlity -
EVEN if the RFC reference is updated (the new RFC does not specify the
USAGE of "-" either).
[CNG] If there's no syntax problem then what happens if a H.248.1 MGC
using "-" tries to use it on a MG that doesn't support it? A SDP syntax
error results because "-" cannot be present in an RFC2327 in a m= line.
If RFC4566 was supported then you wouldn't get the basic syntax error
because "-" IS supported in the m=line.

A further issue is once the value is supported in the syntax to define
what the MG is going to do with it....

We can't retrospectively had new syntax to H.248.1 in v1, v2 and v3
because we introduce the above syntax problem.

>>Having said that I think Albrecht's approach is a pragmatic way
forward.
>>In addition the Tispan work could adopt the "application" example as
outlined above for media unaware MGs.
>>
>>
>
>I think TISPAN can continue using "-" even in future versions of the Ia
profile. We can discuss whether we just add some clarification text to
the Ia profile, and/or if we update the SDP reference in Ia from 2327 to
4566. I see no problem in having profiles refering 4566, even if H.248.1
refers 2327, so I don't think the "legalizing" Albrecht is talking about
is needed.
[CNG] Profiles were about enhancing interoperability. Adding things to
syntax, do things in a different way to the core specification certainly
doesn't assist in those aims.

>My first choise, however, would still be to update H.248.1, but if we
can't agree on that I can live with some compromise.
>
>Regards,
>
>Christer
>
>
>
>
>Regards, Christian
>
>Christer Holmberg (JO/LMF) wrote:
>
>
>
>>Hi,
>>
>>Eventhough I would prefer "data" over "omit", there are still some
issues.
>>
>>First, "data" has been removed from RFC4566 (new SDP RFC), due to
"unclear usage". It can still be used, though, so I don't think that is
a major issue. I even think there are use-cases where "data" is needed,
but that is a separate discussion.
>>
>>But, if you use "data", wouldn't you expect something specific in the
fmt field? Remember that Ia uses "-" in the fmt field also, because Ia
simply doesn't care.
>>
>>So, it's not only the media type where we need to be able to indicate
"don't care".
>>
>>In fact, it's not even only in the m= line where we need it. H.248.20
uses "-" in the c= line.
>>
>>H.248.20 does say that any value can be used, and that "-" is simply a
recommendation. But, in the H.248.20 case we don't have the problem that
the receiver sometimes shall care, and in other cases it doesn't need to
care. But, again, in Ia we will have that problem once/if media
awareness is added to the profile.
>>
>>So, I think it would be good if H.248.1 said that "-" can be used in
ALL SDP parameter fields, because in future we may find other places
where it may be needed.
>>
>>Regards,
>>
>>Christer
>>
>>
>>
>>
>>
>>
>>
>>
>>-----Original Message-----
>>From: Christian Groves [mailto:[email-masked]]
>>Sent: 4. elokuuta 2006 4:28
>>To: CHATRAS Bruno RD-CORE-ISS
>>Cc: Christer Holmberg (JO/LMF); [email-masked];
>>[email-masked]; Campos, Simao
>>Subject: Re: [Megaco] ETSI H.248 Ia Profile: issue with media value
>>'-'in SDP"m=" line
>>
>>Hello Bruno and Christer,
>>
>>If this the MG is media unaware isn't this then a "data service"? and
DATA can be used as a media type and the appropriate fields used?
>>
>>If we're not extending to all properties then wouldn't the required
properties need to explained in any additions?
>>
>>Regards, Christian
>>
>>CHATRAS Bruno RD-CORE-ISS wrote:
>>
>>
>>
>>
>>
>>>I would of course vote of option a) as well. I don't think we need to
extend this to all properties. This convention can be restricted to SDP
fields.
>>>
>>>The Binary case is different. If SDP fields are represented by
dedicated tags (e.g. Media/1001), then the MGC can simply omit the
parameters that are meaningless. If the SDP equivalent (e.g. SDP_M) are
used then the "-" convention shall also be used in the valeu field of
the TLV parameter.
>>>
>>>Regards,
>>>Bruno
>>>
>>>-----Message d'origine-----
>>>De : Christer Holmberg [mailto:[email-masked]]
>>>Envoyé : mardi 25 juillet 2006 09:34
>>>À : Christian Groves; [email-masked] Cc : CHATRAS Bruno
>>>RD-CORE-ISS; [email-masked]; Campos, Simao Objet : Re: [Megaco] ETSI
>>>H.248 Ia Profile: issue with media value '-'in SDP"m=" line
>>>
>>>Hi Christian,
>>>
>>>As Bruno also said, in future the Ia profile may become media aware,
so we can't just say that "-" means that you can send whatever you want
since the receiver doesn't care about the value. We will need a
dedicated "do not care" value, so that the receiver knows whether it
should care or not.
>>>
>>>For the response I would vote for option a).
>>>
>>>Regards,
>>>
>>>Christer
>>>
>>>________________ Reply Header ________________
>>>Subject:        Re: [Megaco] ETSI H.248 Ia Profile: issue with media
value        '-'in SDP"m=" line
>>>Author:         "Christian Groves" <[email-masked]>
>>>Date:                       25th July 2006 10:06:12 am
>>>
>>>Hello All,
>>>
>>>I'm not really comfortable with this being added via the way of the
implementors guide (e.g. I don't support this). In an earlier email
Bruno had concerns other the ability of ability of previous Ia
implementations to accept a CR on this. I think we strike the same (if
not bigger) problem if we simply state "-" is supported. I would assume
there are a lot more H.248.1 implementations than Ia implementations out
there. If we added this we would be introducing a possible error to a
greater set of implementations.
>>>
>>>I would also consider the use of "-" as new functionality. Is this
used in command requests AND responses?
>>>
>>>Let's look at the original text from the Ia profile:
>>>"-" may be used for the transport value, unless transport specific
behaviour is required by the MG.
>>>"-" may be used for the format list value. Other values shall be
ignored.
>>>
>>>Now H.248 requires that fully compliant SDP be returned in the
command response. So what does this text really mean?
>>>a) Does "-" mean the MGC doesn't care and return "-" in the command
reply?
>>>b) Does "-" mean the MGC doesn't care but its up to the MG to choose
something.
>>>c) The Ia profile doesn't care what is put there. Any valid SDP can
be used.
>>>
>>>If its a) then its definately not an implementor's guide change. As
now we have to change things in command requests and responses. Do we
also need to add this "don't care" to all properties. e.g. for the
ASN.1?
>>>If its b) then it sound like CHOOSE ? is really what it being
requested.
>>>If its c) I believe is the original intention from profiles and was
probably lost in translation (e.g. a derivitive of the Q.1950 text) then
"-" is never sent and this can be fixed in the Ia profile which
introduced this problem.
>>>
>>>Regards, Christian
>>>
>>>[email-masked] wrote:
>>>
>>>
>>>
>>>
>>>
>>>
>>>
>>>>Hi,
>>>>
>>>>it's a syntax issue. An implementation following strictly ES 283 018
>>>>v1.1.1 may not work due to RFC 2327 and H.248.1 (09/2005) baseline
>>>>(in my understanding of the profile specification).
>>>>'-' is an implicit SDP syntax extension in ES 283 018 IMHO.
>>>>
>>>>I do accept all your arguments in favour for '-', i.e. I won't
>>>>submit a CR for 'OMIT'.
>>>>I do support the clarification proposal for H.248.1 from
Kevin/Christer.
>>>>I'll submit a CR for a new NOTE in Table 81/ES 283 018, pointing out

>>>>explicitly the syntax extension.
>>>>
>>>>Thanks,
>>>>regards,
>>>>
>>>>Albrecht
>>>>
>>>>
>>>>
>>>>
>>>>

>>>>                   "Christer Holmberg

>>>>                   \(JO/LMF\)"                   To:      "Kevin
Boyle" <[email-masked]>, "CHATRAS Bruno RD-CORE-ISS"

>>>>                   <christer.holmberg@er
<[email-masked]>, Albrecht SCHWARZ/DE/ALCATEL@ALCATEL

>>>>                   icsson.com>                   cc:
[email-masked]

>>>>                                                 Subject: RE:
[Megaco] ETSI H.248 Ia Profile: issue with media value '-'in  SDP"m="
line
>>>>                   21.07.2006 16:42

>>>>
>>>>
>>>>
>>>>
>>>>
>>>>Hi,
>>>>
>>>>What we need to say is that "-" is allowed in H.248 usage of SDP(in
>>>>case
>>>>H.248.1 still refers to RFC 2327), and we need to say what a "-"
>>>>value means.
>>>>
>>>>Regards,
>>>>
>>>>Christer
>>>>
>>>>
>>>>-----Original Message-----
>>>>From: Kevin Boyle [mailto:[email-masked]]
>>>>Sent: 21. heinäkuuta 2006 17:23
>>>>To: Christer Holmberg (JO/LMF); CHATRAS Bruno RD-CORE-ISS;
>>>>[email-masked]
>>>>Cc: [email-masked]
>>>>Subject: RE: [Megaco] ETSI H.248 Ia Profile: issue with media value
>>>>'-'in SDP"m=" line
>>>>
>>>>I will draft something to be included in the next IG.  Even though
>>>>we are talking about something syntactical in nature, the syntax is
>>>>that of SDP and not H.248.  It also appears that there is a common
>>>>understanding of how this is to be used.  Therefore, I think this
>>>>falls into the realm of clarification and not as a change to the
procedures of the protocol.
>>>>
>>>>As for updating the reference to 4566, I will have to ask the TSB if

>>>>that is acceptable in the IG, or if we should look to prepare a
>>>>Corrigendum in November.
>>>>
>>>>Kevin
>>>>
>>>>-----Original Message-----
>>>>From: Christer Holmberg (JO/LMF)
>>>>[mailto:[email-masked]]
>>>>Sent: Friday, July 21, 2006 5:18 AM
>>>>To: CHATRAS Bruno RD-CORE-ISS; [email-masked]
>>>>Cc: [email-masked]
>>>>Subject: RE: [Megaco] ETSI H.248 Ia Profile: issue with media value
>>>>'-'in SDP"m=" line
>>>>
>>>>
>>>>Hi,
>>>>
>>>>I agree with Bruno.
>>>>
>>>>Also, H.248.1 does already "extend" RFC 2327, by defining some SDP
>>>>values which are not allowed by the RFC, e.g. "*" and "$".
>>>>
>>>>I think a solution would be to add text to H.248.1, allowing also
the "-"
>>>>value and define what it is used for (similar to "*" and "$").
>>>>
>>>>(It would of course have been good to define the meaning of "-" in
>>>>RFC 4566, in case some other protocol needs it, but it's too late
>>>>now.)
>>>>
>>>>Regards,
>>>>
>>>>Christer
>>>>
>>>>
>>>>
>>>>-----Original Message-----
>>>>From: CHATRAS Bruno RD-CORE-ISS [mailto:[email-masked]]
>>>>Sent: 21. heinäkuuta 2006 10:26
>>>>To: Christer Holmberg (JO/LMF); [email-masked]
>>>>Cc: [email-masked]
>>>>Subject: RE: [Megaco] ETSI H.248 Ia Profile: issue with media value
>>>>'-'in SDP"m=" line
>>>>
>>>>Moreover, even if a CR was issued agaisnt ES 283 018 to recommend
>>>>using the OMIT token rather than the "-", the "-" would have to be
>>>>kept in the Ia profile anyway for backward compatibility purposes. I

>>>>assume that we would not like an IP2IP MG to reject an H.248 command

>>>>just because it contains a "-" sent by an MGC that has not
implemented the CR yet.
>>>>
>>>>Regards,
>>>>Bruno
>>>>
>>>>-----Message d'origine-----
>>>>De : Christer Holmberg (JO/LMF)
>>>>[mailto:[email-masked]]
>>>>Envoyé : jeudi 20 juillet 2006 20:46 À : [email-masked]

>>>>Cc : [email-masked] Objet : RE: [Megaco] ETSI H.248 Ia Profile:
>>>>issue with media value '-'in SDP"m=" line
>>>>
>>>>
>>>>Hi,
>>>>
>>>>Why can't the Ia profile be based on RFC 4566? RFC 3108 is not
>>>>referenced by the Ia profile, or by H.248.1.
>>>>
>>>>Also, my understanding is that RFC 3108 DOES recommend "-", but says

>>>>that "OMIT" can be used due to the syntax issue with RFC 2327.
>>>>
>>>>Also, in the RFC 3108 examples "-" is used.
>>>>
>>>>Regards,
>>>>
>>>>Christer
>>>>
>>>>
>>>>-----Original Message-----
>>>>From: [email-masked]
>>>>[mailto:[email-masked]]
>>>>Sent: 20. heinäkuuta 2006 12:00
>>>>To: Christer Holmberg (JO/LMF)
>>>>Cc: [email-masked]
>>>>Subject: RE: [Megaco] ETSI H.248 Ia Profile: issue with media value
>>>>'-'in SDP "m=" line
>>>>
>>>>
>>>>Christer, et al.,
>>>>
>>>>I was aware of the SDP extension by '-' in "SDP new" (guess will be
>>>>RFC 4566), when writting my email.
>>>>(I was not aware of the Q.1950 SDP extensions, but I didn't consider

>>>>them because Q.1950 is irrelevant for ETSI ES 283 018.)
>>>>
>>>>We came finally to the conclusion that:
>>>>'OMIT' seems to be the best compromise because
>>>>* compliant to RFC 2327,
>>>>* ETSI ES 283 018 v1.1.1 is based on RFC 2327,
>>>>* when the H.248 Ia Profile will be based on RFC 4566 is still
>>>>unclear to me ("I guess that first H.248.1 will obsolete RFC 2327
>>>>and then replace it by RFC 4566, but whether this is a
>>>>straightforward task or not, I don't know. Next step then H.248
>>>>profiles ..."),
>>>>* 'OMIT' already recommended (& defined) by RFC 3108 for
"media-agnostic"
>>>>SDP descriptors, so 'OMIT' is not totally new, and
>>>>* 'OMIT' is inline with separating into media-agnostic and
>>>>media-aware IP terminations, and
>>>>* '-' would be an extension of the SDP grammar of RFC 2327 based
>>>>H.248 profiles.
>>>>
>>>>We will submitt a correspondent CR to next TISPAN meeting.
>>>>
>>>>Regards,
>>>>Albrecht
>>>>
>>>>
>>>>
>>>>
>>>>                   "Christer Holmberg
>>>>
>>>>                   \(JO/LMF\)"                   To:      "Kevin
Boyle"
>>>><[email-masked]>, "B Venkat S.R Swamy"
>>>>                   <christer.holmberg@er
>>>><[email-masked]>, "Christian Groves"
>>>><[email-masked]>
>>>>                   icsson.com>                   cc:      Albrecht
>>>>SCHWARZ/DE/ALCATEL@ALCATEL, [email-masked]
>>>>                                                 Subject: RE:
>>>>[Megaco] ETSI H.248 Ia Profile: issue with media  value '-'inSDP"m="
line
>>>>                   17.07.2006 22:00
>>>>
>>>>
>>>>
>>>>
>>>>
>>>>
>>>>
>>>>Hi,
>>>>
>>>>According to draft-ietf-mmusic-sdp-new-26, which will replace RFC
2327, "-"
>>>>IS allowed.  Both the media and the fmt parts of the m= line are
>>>>defined as tokens.
>>>>
>>>>media =               token
>>>>                         ;typically "audio", "video", "text" or
>>>>                         ;"application"
>>>>
>>>>fmt =                 token
>>>>                         ;typically an RTP payload type for audio
>>>>                         ;and video media
>>>>
>>>>token =               1*(token-char)
>>>>
>>>>token-char =          %x21 / %x23-27 / %x2A-2B / %x2D-2E / %x30-39 /
>>>>%x41-5A / %x5E-7E
>>>>
>>>>(The ascii code for "-" is %x2D)
>>>>
>>>>
>>>>Regards,
>>>>
>>>>Christer
>>>>
>>>>
>>>>
>>>>-----Original Message-----
>>>>From: Kevin Boyle [mailto:[email-masked]]
>>>>Sent: 17. heinäkuuta 2006 19:58
>>>>To: B Venkat S.R Swamy; Christian Groves
>>>>Cc: [email-masked]; [email-masked]; Christer Holmberg
>>>>(JO/LMF)
>>>>Subject: RE: [Megaco] ETSI H.248 Ia Profile: issue with media value
>>>>'-'inSDP"m=" line
>>>>
>>>>The MGC could place "$" there if it truly did not care.  This would
>>>>align better with the intent of both SDP and H.248.
>>>>
>>>>Kevin
>>>>
>>>>________________________________
>>>>
>>>>From: B Venkat S.R Swamy [mailto:[email-masked]]
>>>>Sent: Monday, July 17, 2006 12:40 AM
>>>>To: Christian Groves
>>>>Cc: [email-masked]; [email-masked];
>>>>[email-masked]
>>>>Subject: Re: [Megaco] ETSI H.248 Ia Profile: issue with media value
'-'
>>>>inSDP"m=" line
>>>>
>>>>
>>>>
>>>>Hi
>>>>
>>>>Although you are right these are don't care values, but the point
>>>>here was SDP grammar does not support "-" in the media as shown
below.
>>>>
>>>>"m=" media space port ["/" integer] space proto 1*(space fmt) CRLF
>>>>
>>>>media =               1*(alpha-numeric)
>>>>;typically "audio", "video", "application"
>>>>;or "data"
>>>>
>>>>therefore the string "OMIT" was suggested for the media, so as not
>>>>to violate the SDP grammar.
>>>>
>>>>
>>>>regards
>>>>B Venkat S.R Swamy
>>>>Senior Technical Leader
>>>>Flextronics Software Systems
>>>>Phone: +91-124- 4176213
>>>>Fax: +91-124-4300247
>>>>web: www.flextronicssoftware.com
>>>>Christian Groves <[email-masked]>

_______________________________________________
Megaco mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/megaco